/*
*  Rubrica
*  file: error.c
*  
*  Copyright (C) 2000-2001 Nicola Fragale <nicolafragale@libero.it>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
/* 
   Per favore non eliminate i commenti in italiano 
   Non tutti gli italiani conoscono l'inglese.
*/

#include <gnome.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include "support.h"

#include "error.h"

void 
rubrica_error_selezionare_elemento(void)
{
  GtkWidget *messagebox;
  GtkWidget *dialog_vbox1;
  GtkWidget *button1;
  GtkWidget *dialog_action_area1;

  messagebox = gnome_message_box_new (_("Warning!\nYou must select a card, before continue."), GNOME_MESSAGE_BOX_ERROR, NULL);

  gtk_object_set_data (GTK_OBJECT (messagebox), "messagebox", messagebox);
  gtk_container_set_border_width (GTK_CONTAINER (messagebox), 5);
  gtk_window_set_title (GTK_WINDOW (messagebox), _("Info"));
  gtk_window_set_position (GTK_WINDOW (messagebox), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (messagebox), TRUE);
  gtk_window_set_policy (GTK_WINDOW (messagebox), FALSE, FALSE, FALSE);

  dialog_vbox1 = GNOME_DIALOG (messagebox)->vbox;
  gtk_object_set_data (GTK_OBJECT (messagebox), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  gnome_dialog_append_button (GNOME_DIALOG (messagebox), GNOME_STOCK_BUTTON_OK);
  button1 = g_list_last (GNOME_DIALOG (messagebox)->buttons)->data;
  gtk_widget_ref (button1);
  gtk_object_set_data_full (GTK_OBJECT (messagebox), "button1", button1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button1);
  GTK_WIDGET_SET_FLAGS (button1, GTK_CAN_DEFAULT);

  dialog_action_area1 = GNOME_DIALOG (messagebox)->action_area;
  gtk_widget_ref (dialog_action_area1);
  gtk_object_set_data_full (GTK_OBJECT (messagebox), "dialog_action_area1", 
			    dialog_action_area1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show(messagebox);
}


void 
rubrica_error_cancellazione(void)
{
  GtkWidget *dialogo, *label;

  dialogo = gnome_dialog_new(_("Warning"), GNOME_STOCK_BUTTON_OK, NULL);
  label = gtk_label_new(_("Warning!\nI can't delete the selected card"));
  gtk_window_set_modal (GTK_WINDOW (dialogo), TRUE);
  gtk_widget_show(label);
  gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialogo)->vbox), label, TRUE, TRUE, 0);

  gnome_dialog_run_and_close(GNOME_DIALOG(dialogo));
}


void 
rubrica_error_modifica(void)
{
  GtkWidget *dialogo, *label;

  dialogo = gnome_dialog_new(_("Warning"), GNOME_STOCK_BUTTON_OK, NULL);
  label =  gtk_label_new(_("Warning!\nI can't modify the selected card."));
  gtk_window_set_modal (GTK_WINDOW (dialogo), TRUE);
  gtk_widget_show(label);
  gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialogo)->vbox), label, TRUE, TRUE, 0);

  gnome_dialog_run_and_close(GNOME_DIALOG(dialogo));
}


void 
rubrica_non_implementato(void)
{
  GtkWidget *dialogo, *label;

  dialogo = gnome_dialog_new(_("Warning"), GNOME_STOCK_BUTTON_OK, NULL);
  label = gtk_label_new(_("Warning!\nThis function isn't yet implemented\n"));
  gtk_window_set_modal (GTK_WINDOW (dialogo), TRUE);
  gtk_widget_show(label);
  gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialogo)->vbox), label, TRUE, TRUE, 0);

  gnome_dialog_run_and_close(GNOME_DIALOG(dialogo));  
}

void 
rubrica_error_rubrica_empty()
{
  GtkWidget *dialogo, *label;
  
  dialogo = gnome_dialog_new(_("Warning"), GNOME_STOCK_BUTTON_OK, NULL);
  label = gtk_label_new(_("Warning!\nAddress book is empty. I can't continue\n"));
/*  gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_LEFT); */
  gtk_window_set_modal (GTK_WINDOW (dialogo), TRUE);
  gtk_widget_show(label);
  gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialogo)->vbox), label, TRUE, TRUE, 0);

  gnome_dialog_run_and_close(GNOME_DIALOG(dialogo));  
}

void rubrica_error_no_item_found(void)
{
  rubrica_non_implementato();
}

void rubrica_error_no_string(void)
{
  rubrica_non_implementato();
}

void rubrica_error_import_no_file(void)
{
  GtkWidget *dialogo, *label;

  dialogo = gnome_dialog_new(_("Error"), GNOME_STOCK_BUTTON_OK, NULL);
  label =  gtk_label_new(_("Error!\nI can't read the file."));
  gtk_window_set_modal (GTK_WINDOW (dialogo), TRUE);
  gtk_widget_show(label);
  gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialogo)->vbox), label, 
		     TRUE, TRUE, 0);
  gnome_dialog_run_and_close(GNOME_DIALOG(dialogo));
}

void rubrica_error_save_config(gchar *str)
{
  rubrica_non_implementato();
}


void rubrica_error_generic(gchar *str)
{
  GtkWidget *generic_error;
  GtkWidget *dialog_vbox1;
  GtkWidget *button1;
  GtkWidget *dialog_action_area1;

  /* We create it with an OK button, and then remove the button, to work
     around a bug in gnome-libs. */
  g_warning("%s", str);
  generic_error = gnome_message_box_new (str,
                              GNOME_MESSAGE_BOX_ERROR,
                              GNOME_STOCK_BUTTON_OK, NULL);
  gtk_container_remove (GTK_CONTAINER (GNOME_DIALOG (generic_error)->action_area), 
			GNOME_DIALOG (generic_error)->buttons->data);
  GNOME_DIALOG (generic_error)->buttons = NULL;
  gtk_object_set_data (GTK_OBJECT (generic_error), "generic_error", generic_error);
  gtk_window_set_title (GTK_WINDOW (generic_error), _("Error"));
  gtk_window_set_position (GTK_WINDOW (generic_error), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (generic_error), TRUE);

  dialog_vbox1 = GNOME_DIALOG (generic_error)->vbox;
  gtk_object_set_data (GTK_OBJECT (generic_error), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  gnome_dialog_append_button (GNOME_DIALOG (generic_error), GNOME_STOCK_BUTTON_OK);
  button1 = GTK_WIDGET (g_list_last (GNOME_DIALOG (generic_error)->buttons)->data);
  gtk_widget_ref (button1);
  gtk_object_set_data_full (GTK_OBJECT (generic_error), "button1", button1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button1);
  GTK_WIDGET_SET_FLAGS (button1, GTK_CAN_DEFAULT);

  dialog_action_area1 = GNOME_DIALOG (generic_error)->action_area;
  gtk_widget_ref (dialog_action_area1);
  gtk_object_set_data_full (GTK_OBJECT (generic_error), "dialog_action_area1", 
			    dialog_action_area1,(GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_show(generic_error);
}










